@scala.annotation.tailrec
def factorial(
  fact : BigInt, number : Int) : BigInt = {
  if(number == 1)
    fact
  else
   factorial(number * fact, number - 1)
}

println(factorial(1, 50000))

//Tail call optimization (TCO)
//compiler optimizes tail calls to 
//a mere iteration under the hood.

